(define-module (ui clamav ajax)
  :use-module (alterator ajax)
  :use-module (alterator algo)
  :use-module (alterator woo)
  :use-module (alterator effect)
  :export (init))

(define (ui-init)
    (form-update-value-list
      (woo-read-first "/clamav/status" 
        'language (form-value "language")))
    (form-update-visibility "hidable_main" #t)
    (form-update-visibility "ss_btn" #t)
)

(define (change_daemon)
    (catch/message
	(lambda() (woo-write "/clamav/daemon" 'status (form-value "daemon"))))
    (form-update-value-list
      '("cur_status" ) (woo-read-first "/clamav/state" 
      'language (form-value "language"))))

(define (restart_daemon)
    (catch/message
    (lambda() (woo-write "/clamav/reload")))
    (form-update-value-list
      '("cur_status" ) (woo-read-first "/clamav/state"))
)

(define (update_bases)
    (catch/message
    (lambda() (woo-write "/clamav/update_bases")))

)

(define (update_settings)
    (catch/message
      (lambda() 
	(apply woo-write "/clamav/write_settings" 
	    'language (form-value "language")
	    (form-value-list))
	    (ui-init)
	    (update-effect)))
    (form-update-visibility "hidable_settings" #f)
    (form-update-visibility "Apply_btn" #f)
    (form-update-visibility "Return_btn" #f)
    (form-update-visibility "hidable_main" #t)
    (form-update-visibility "ss_btn" #t)
)

(define (change_cron)
    (catch/message
	(lambda() (woo-write "/clamav/set_cron" 
	    'time (form-value "update_period"))))
)

(define (change_crontab)
    (catch/message
	(lambda() (woo-write "/clamav/enable_cron" 'cron (form-value "enable_updates"))))
    (form-update-activity "update_period" (form-value "enable_updates"))
)

(define (show_settings)
    (form-update-visibility "hidable_settings" #t)
    (form-update-visibility "Apply_btn" #t)
    (form-update-visibility "Return_btn" #t)
    (form-update-visibility "ss_btn" #f)
    (form-update-visibility "hidable_main" #f)
)

(define (return_settings)
    (form-update-visibility "hidable_settings" #f)
    (form-update-visibility "Apply_btn" #f)
    (form-update-visibility "Return_btn" #f)
    (form-update-visibility "ss_btn" #t)
    (form-update-visibility "hidable_main" #t)
)

(define (inspect)
    (form-replace "/clamav/quarantine"))

(define (init)
    (ui-init)

    (effect-show "proxy_url" "use_proxy" #t)
    (effect-enable "q_path" "use_quarantine" #t)
    (effect-enable "x_header" "use_header" #t)
    (effect-enable "va_script" "use_vascript" #t)
    (init-effect)
    (form-bind "ss_btn" "click" show_settings)
    (form-bind "daemon" "change" change_daemon)
    (form-bind "update_period" "change" change_cron)
    (form-bind "enable_updates" "change" change_crontab)
    (form-bind "reload_btn" "click" restart_daemon)
    (form-bind "update_btn" "click" update_bases)
     (form-bind "quarantine_btn" "click" inspect)
    (form-bind "Apply_btn" "click" update_settings)
    (form-bind "Return_btn" "click" return_settings)
)
